web-dev-qa-db-de.com

Maven - Fehler beim Ausführen des Ziels org.Apache.maven.plugins: maven-compiler-plugin: 3.7.0: compile using Java 10

ich versuche, mein Diskord-Bot-Projekt mit Git bash auf Heroku hochzuladen. Mein Projekt ist Java 10 und ich benutze Maven.

remote:        [ERROR] Failed to execute goal org.Apache.maven.plugins:maven-compiler-plugin:3.7.0:compile (default-compile) on project bot_discord: Fatal error compiling: invalid flag: --release -> [Help 1]
remote:        [ERROR]
remote:        [ERROR] To see the full stack trace of the errors, re-run Maven with the -e switch.
remote:        [ERROR] Re-run Maven using the -X switch to enable full debug logging.
remote:        [ERROR]
remote:        [ERROR] For more information about the errors and possible solutions, please read the following articles:
remote:        [ERROR] [Help 1] http://cwiki.Apache.org/confluence/display/MAVEN/MojoExecutionException
remote:
remote:  !     ERROR: Failed to build app with Maven
remote:        We're sorry this build is failing! If you can't find the issue in application code,
remote:        please submit a ticket so we can help: https://help.heroku.com/
remote:
remote:  !     Push rejected, failed to compile Java app.
remote:
remote:  !     Push failed

ich denke, ich muss etwas zu meinem Pom.xml hinzufügen, aber ich verstehe nicht, was ich hinzufügen soll! Mein Pom.xml:

<project xmlns="http://maven.Apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.Apache.org/POM/4.0.0 http://maven.Apache.org/xsd/maven-4.0.0.xsd">
  <modelVersion>4.0.0</modelVersion>
  <groupId>kino.bot</groupId>
  <artifactId>bot_discord</artifactId>
  <version>0.0.1-SNAPSHOT</version>
  <name>Bot Ryo</name>
  <description>Mon bot</description>
  <build>
    <sourceDirectory>src</sourceDirectory>
    <plugins>
      <plugin>
        <artifactId>maven-compiler-plugin</artifactId>
        <version>3.7.0</version>
        <configuration>
          <release>10</release>
        </configuration>
      </plugin>
    </plugins>
  </build>


  <repositories>
    <repository>
        <id>jcenter</id>
        <name>jcenter-bintray</name>
        <url>http://jcenter.bintray.com</url>
    </repository>
    <repository>
        <id>jitpack.io</id>
        <url>https://jitpack.io</url>
    </repository>
  </repositories>

  <dependencies>
    <dependency>
        <groupId>net.dv8tion</groupId>
        <artifactId>JDA</artifactId>
        <version>3.7.1_422</version>
    </dependency>
    <dependency>
        <groupId>com.mashape.unirest</groupId>
        <artifactId>unirest-Java</artifactId>
        <version>1.4.9</version>
    </dependency>
  </dependencies>

</project>

was muss ich meiner pom.xml hinzufügen?

1
Crøss Marian

Stellen Sie sicher, dass sich die system.properties-Datei im Stammverzeichnis Ihres Repositorys mit folgendem Inhalt befindet:

Java.runtime.version=10

Weitere Informationen finden Sie in der Heroku-Dokumentation zu Java-Versionen

0
codefinger

Das Argument -release wird nur seit Java9 unterstützt ( https://maven.Apache.org/plugins/maven-compiler-plugin/compile-mojo.html ). Stellen Sie sicher, dass Ihre Maven-Installation mindestens Java9 verwendet. 

1
user10367961

Versuchen Sie es mit Version 3.8.0 anstelle von 3.7.0. Stellen Sie außerdem sicher, dass Java_HOME auf Ihre Java 8-Installation eingestellt ist. Siehe diesen Link

0
tom

Es gibt eine weitere Option, anstatt die Eigenschaftendatei am Repo-Speicherort hinzuzufügen. 

Sie können diesen Code in POM.xml hinzufügen:

<properties>
    <Java.version>1.8.0_171</Java.version>
</properties>
0
HARSH KHATRI